﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace ClickingGame
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        //atributy
        DispatcherTimer gameTimer = new DispatcherTimer();
        int score = 0;
        Random rand = new Random();
        int spawnRate = 20;
        int currentRate;
        float growRate = 0.6f;
        int health = 350;

        public MainWindow()
        {
            InitializeComponent();

            //akce po spusteni
            gameTimer.Interval = TimeSpan.FromMilliseconds(20);
            gameTimer.Tick += GameLoop;
            gameTimer.Start();

            currentRate = spawnRate;
        }

        private void GameLoop(object sender, EventArgs e)
        {
            //score++;
            lbScore.Content = "Score: " + score;
            currentRate -= 2;  

            if (currentRate < 1)  
            {  

                int posX = rand.Next(15, 700);
                int posY = rand.Next(50, 350);

                SolidColorBrush brush = new SolidColorBrush(Color.FromRgb(
                    (byte)rand.Next(0, 255), (byte)rand.Next(0, 255), (byte)rand.Next(0, 255)
                    ));

                Ellipse circle = new Ellipse()
                {
                    Height = 30,
                    Width = 30,
                    Stroke = Brushes.Black,
                    StrokeThickness = 1,
                    Fill = brush
                };

                Canvas.SetLeft(circle, posX);
                Canvas.SetTop(circle, posY);

                MyCanvas.Children.Add(circle);
                currentRate = spawnRate; 
            }  

            //animace
            foreach (var x in MyCanvas.Children.OfType<Ellipse>().Reverse())
            {
                x.Height += growRate;
                x.Width += growRate;
                x.RenderTransformOrigin = new Point(0.5, 0.5);

                if (x.Width>70)
                {
                    MyCanvas.Children.Remove(x);
                    health -= 15;
                }
            }

            //prekresleni healthBar a ukonceni
            if (health > 1)
                healthBar.Width = health;
            else
            {
                MessageBox.Show("GAME OVER");
                this.Close();
            }

        }

        private void MyCanvas_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.OriginalSource is Ellipse)
            {
                score++;
                Ellipse circle = (Ellipse)e.OriginalSource;
                MyCanvas.Children.Remove(circle);
            }
        }
    }
}
